<template>
  <div>
    <div v-show="stepperValue === 3">
      <v-progress-linear :value="evaluationProgress - 50"></v-progress-linear>
    </div>
    <div class="w-full flex flex-row justify-center">
      <div class="w-3/4">
        <v-stepper v-model="stepperValue" class="shadow-none">
          <v-stepper-header class="shadow-none">
            <v-stepper-step step="1" :complete="stepperValue > 1"
              >Choix du savoir</v-stepper-step
            >
            <v-stepper-step step="2" :complete="stepperValue > 2"
              >Choix de la date de l'évalution
            </v-stepper-step>
            <v-stepper-step step="3" :complete="stepperValue > 3"
              >Evaluation
            </v-stepper-step>
          </v-stepper-header>
          <v-stepper-items>
            <div class="italic text-sm p-7" v-if="matieres.length === 0">
              Pas de matières ajoutées
            </div>
            <v-stepper-content step="1">
              <v-expansion-panels flat>
                <v-expansion-panel
                  v-for="matiere in matieres"
                  :key="matiere.id"
                  @click="selectMatiere(matiere)"
                >
                  <v-expansion-panel-header>
                    <div class="font-semibold text-xl">
                      {{ matiere.nom }}
                    </div>
                  </v-expansion-panel-header>
                  <v-expansion-panel-content>
                    <div v-if="savoirs.length === 0">
                      <div class="italic text-sm">
                        Pas de savoirs correspondants dans le bulletin
                      </div>
                    </div>
                    <div v-for="savoir in savoirs" :key="savoir.id">
                      <div
                        v-ripple
                        class="select-none cursor-pointer p-3 hover:bg-gray-100"
                        @click="selectSavoir(savoir)"
                      >
                        <div>{{ savoir.nom }}</div>
                      </div>
                    </div>
                  </v-expansion-panel-content>
                </v-expansion-panel>
              </v-expansion-panels>
            </v-stepper-content>
            <v-stepper-content step="2" class="">
              <div class="flex justify-center">
                <v-date-picker
                  class="border-none w-1/2"
                  v-model="date"
                  full-width
                  locale="fr-fr"
                ></v-date-picker>
              </div>
              <div class="flex flex-row p-3 justify-between">
                <v-btn text @click.native="stepperValue--"> Retour </v-btn>
                <v-btn text color="primary" @click.native="stepperValue++"
                  >Continuer</v-btn
                >
              </div>
            </v-stepper-content>
            <v-stepper-content step="3">
              <div>
                <v-tabs v-model="tabs">
                  <v-tab-item v-for="eleve in eleves" :key="eleve.id" class="">
                    <div class="flex justify-center">
                      <v-form
                        lazy-validation
                        ref="form"
                        v-model="valid"
                        @submit.prevent="evaluateEleve(eleve)"
                      >
                        <div class="flex flex-col border rounded-xl p-5">
                          <eleve-card-item
                            :eleve="eleve"
                            :showMoyenne="false"
                            :showUpdate="false"
                            :enableHover="false"
                          />
                          <div
                            v-if="bulletin.classe.typeEvaluations === 'acquis'"
                          >
                            <div>
                              <v-radio-group
                                row
                                v-model="currentEvaluation"
                                :disabled="currentAbsent"
                              >
                                <v-radio
                                  label="A."
                                  value="A."
                                  color="#34D399"
                                />
                                <v-radio
                                  label="E.V.A."
                                  value="E.V.A."
                                  color="#FBBF24"
                                />
                                <v-radio
                                  label="N.A."
                                  value="N.A."
                                  color="#F87171"
                                />
                              </v-radio-group>
                              <v-textarea
                                auto-grow
                                rows="2"
                                label="Commentaire"
                                v-model="currentCommentaire"
                              />
                              <v-checkbox
                                label="Absent"
                                v-model="currentAbsent"
                              />
                            </div>
                          </div>
                          <div class="grid grid-cols-2 gap-20" v-else>
                            <div>
                              <v-text-field
                                label="Nominateur"
                                type="number"
                                required
                                :rules="
                                  currentAbsent ? undefined : nombresRules
                                "
                                v-model="currentNominateur"
                                :disabled="currentAbsent"
                              />
                              <v-text-field
                                label="Dénominateur"
                                type="number"
                                :rules="
                                  currentAbsent ? undefined : nombresRules
                                "
                                required
                                v-model="currentDenominateur"
                                :disabled="currentAbsent"
                              />
                              <v-checkbox
                                label="Absent"
                                v-model="currentAbsent"
                              />
                            </div>
                            <div>
                              <v-textarea
                                label="Commentaire"
                                v-model="currentCommentaire"
                              />
                            </div>
                          </div>
                        </div>
                      </v-form>
                    </div>
                    <div class="flex flex-row justify-between">
                      <v-btn
                        text
                        @click.native="
                          stepperValue == 3 && tabs == 0
                            ? stepperValue--
                            : tabs--
                        "
                      >
                        Retour
                      </v-btn>
                      <v-btn
                        text
                        :disabled="
                          !currentEvaluation &&
                          !currentAbsent &&
                          (!currentNominateur || !currentDenominateur)
                        "
                        color="primary"
                        @click.native="
                          stepperValue != 3
                            ? stepperValue++
                            : evaluateEleve(eleve)
                        "
                        >Continuer</v-btn
                      >
                    </div>
                  </v-tab-item>
                </v-tabs>
              </div>
            </v-stepper-content>
          </v-stepper-items>
        </v-stepper>
      </div>
    </div>
  </div>
</template>

<script>
import EleveCardItem from "../EleveCardItem.vue";
export default {
  components: { EleveCardItem },
  props: {
    value: Boolean,
  },

  computed: {
    matieres() {
      return this.$store.state.matieres;
    },
    eleves() {
      return this.$store.state.eleves;
    },
    classe() {
      return this.$store.getters.getOneClasse(this.$route.params.classeid);
    },
    bulletin() {
      return this.$store.getters.getOneBulletin(this.$route.params.bulletinid);
    },
    evaluationProgress() {
      return (((this.tabs + 1) / this.eleves.length) * 100).toFixed();
    },
  },

  methods: {
    selectMatiere(matiere) {
      this.savoirs = this.$store.getters.savoirsByBulletinAndMatiere(
        this.bulletin,
        matiere
      );
    },
    selectSavoir(savoir) {
      this.savoirSelected = savoir;
      this.stepperValue++;
    },
    closeRequest() {
      this.$emit("closeRequest");
    },

    buildEvaluation() {
      if (!this.currentAbsent) {
        return this.classe.typeEvaluations === "cotes"
          ? {
              nominateur: parseFloat(this.currentNominateur),
              denominateur: parseFloat(this.currentDenominateur),
              coteToText:
                this.currentNominateur.toString() +
                "/" +
                this.currentDenominateur.toString(),
              coteToPourcentage:
                (this.currentNominateur / this.currentDenominateur) * 100,
            }
          : this.currentEvaluation;
      } else return null;
    },
    evaluateEleve(eleve) {
      if (this.$refs.form[0].validate()) {
        this.results.push({
          eleve,
          bulletin: this.bulletin,
          evaluation: this.buildEvaluation(),
          absent: this.currentAbsent,
          savoir: this.savoirSelected,
          commentaire: this.currentCommentaire,
          date: new Date(this.date),
        });
        this.currentEvaluation = undefined;
        this.currentNominateur = undefined;
        this.currentAbsent = false;
        this.currentCommentaire = "";
        if (this.evaluationProgress == "100") this.onModalSubmit();
        this.tabs++;
      }
    },
    onModalSubmit() {
      this.$store.dispatch("addEvaluation", this.results);
      this.$router.replace({ name: "Evaluer" });

      //this.$emit("bulletinSubmit", this.results);
    },
  },
  data() {
    return {
      valid: false,
      tabs: 0,
      savoirs: [],
      savoirSelected: {},
      matiereSelected: {},
      stepperValue: 1,
      date: new Date().toISOString().substr(0, 10),
      results: [],
      currentEvaluation: undefined,
      currentNominateur: undefined,
      currentDenominateur: undefined,
      currentCommentaire: "",
      currentAbsent: false,

      nombresRules: [(v) => !!v || "La valeure est requise"],
    };
  },
};
</script>